#include<iostream>
#include<cmath>
#include<iomanip>
#include<limits>

using namespace std;

double f(double x)
{
	return x*x - 4*sin(x);
}

double bisection(double a, double b, int iterations, double tol)
{
	cout<<"a \t\t f(a) \t\t b \t\t f(b) \t\t m \t\t f(m)"<<endl;
	for ( int i = 0; i < iterations; i++)
	{
		double m = ( a + b ) / 2;
		double fx = f( m );
		double fa = f( a );
		double fb = f( b );
		cout<<setprecision(7)<<showpoint<<a<<"\t"<<fa<<"\t"<<b<<"\t"<<fb<<"\t"<<m<<"\t"<<fx<<"\n";
		if ( fabs( fx ) < tol ) 
			return m;
		if ( fa * fx < 0 ) {
			b = m;
			fb = fx;
		}
		else {	
			a = m;
			fa = fx;
		}
	}
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}


double bisection2(double a, double b, double tol)
{
	cout<<"a \t\t f(a) \t\t b \t\t f(b) \t\t m \t\t f(m)"<<endl;
	while(fabs(b-a)>tol)
	{
		double m = ( a + b ) / 2;
		double fx = f( m );
		double fa = f( a );
		double fb = f( b );
		cout<<setprecision(7)<<showpoint<<a<<"\t"<<fa<<"\t"<<b<<"\t"<<fb<<"\t"<<m<<"\t"<<fx<<"\n";
		if ( fabs( fx ) < tol ) 
			return m;
		if ( fa * fx < 0 ) {
			b = m;
			fb = fx;
		}
		else {	
			a = m;
			fa = fx;
		}
	}
	return std::numeric_limits<double>::quiet_NaN();	//returns NaN when no solution is reached
}



int main()
{
	
	//cout<<"The solution is: "<<bisection(1,3,20,1e-5);
	cout<<"The solution is: "<<bisection2(-1,7,1e-5);
	
	return 0;
}
